import algosdk from 'algosdk'

function sleep(milliseconds) {
  return new Promise(resolve => setTimeout(resolve, milliseconds));
}

async function getAppIndex(txn, net) {

    let data = undefined
    let dataObj = undefined
    let id = undefined
  
    let url = ""

    await sleep(15000)
  
    if (!net) {
      url = "https://algoindexer.testnet.algoexplorerapi.io"
    }
    else {
      url = "https://algoindexer.algoexplorerapi.io"
    }
  
    data = await fetch(url + '/v2/transactions/' + txn)
    dataObj = await data.json()
    id = await dataObj.transaction["created-application-index"]
    window.reachLog += "\nCreated Application: " + id
    return id
  }

  async function waitForConfirmation (algodclient, txId) {
    let response = await algodclient.status().do();
    let lastround = response["last-round"];
    while (true) {
      const pendingInfo = await algodclient.pendingTransactionInformation(txId).do();
      if (pendingInfo["confirmed-round"] !== null && pendingInfo["confirmed-round"] > 0) {
        //Got the completed Transaction
        console.log("Transaction " + txId + " confirmed in round " + pendingInfo["confirmed-round"]);
        break;
      }
      lastround++;
      await algodclient.statusAfterBlock(lastround).do();
    }
  };

async function getAppCreator(net, appid) {
    let data = undefined
    let dataObj = undefined
    let id = undefined

    window.reachLog += "\nFetching creator address..."
  
    let url = ""
  
    if (!net) {
      url = "https://algoindexer.testnet.algoexplorerapi.io"
    }
    else {
      url = "https://algoexplorerapi.io"
    }
  
    data = await fetch(url + '/v2/applications/' + parseInt(appid))
    dataObj = await data.json()
    id = await dataObj.application.params.creator
    window.reachLog += "\nCreator address: " + id
    return id
  }

  function u8array(text) {
    return Uint8Array.from(Array.from(text).map(letter => letter.charCodeAt(0)));
  }

  export {getAppIndex, waitForConfirmation, getAppCreator, u8array}