import MyAlgo from '@randlabs/myalgo-connect'
import WalletConnect from "@walletconnect/client";
import QRCodeModal from "algorand-walletconnect-qrcode-modal";
import { formatJsonRpcRequest } from "@json-rpc-tools/utils";
import { encode, decode } from "algo-msgpack-with-bigint";
import base32 from 'hi-base32';
import { CachedKeyDecoder } from 'algo-msgpack-with-bigint/dist/CachedKeyDecoder';
import createAsaTxn from './createAsaTxn.js'
import { getAppIndex, waitForConfirmation, u8array } from './teal_utils.js';
import algosdk from 'algosdk'
import { configIndexer, configClient, sendTxns } from './utils.js';

//Note: this class is a work in progress. May not work. Roll back version if issues encountered
export default class Pipeline {
    static init() {
        this.EnableDeveloperAPI = false;
        this.indexer = "http://localhost:8980";
        this.algod = "http://localhost:4001";
        this.token = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";
        this.devGenHash = "sC3P7e2SdbqKJK0tbiCdK9tdSpbe6XeCGKdoNzmlj0E="
        this.devGenId = "devnet-v1.0"
        this.index = 0;
        this.pipeConnector = "myAlgoWallet";
        this.main = true;
        this.address = "";
        this.txID = "";
        this.myBalance = 0;
        this.connector = new WalletConnect({
            bridge: "https://bridge.walletconnect.org", // Required
            qrcodeModal: QRCodeModal,
        });
        this.wallet = new MyAlgo();
        return new MyAlgo();
    }

    static async balance(address) {

        let indexerURL = configIndexer(this.main, this.EnableDeveloperAPI)

        let url2 = indexerURL + address
        try {
            let data = await fetch(url2)
            let data2 = await data.json()
            let data3 = JSON.stringify(data2.account.amount / 1000000);
            this.myBalance = data3;
            return data3;
        } catch (error) {
            console.log(error);
            return 0;
        }
    }

    static async connect(wallet) {
        this.address = "";

        switch (this.pipeConnector) {
            case "myAlgoWallet":
                try {
                    const accounts = await wallet.connect()
                    let item1 = accounts[0]
                    item1 = item1['address']
                    this.address = item1;
                    return item1;
                } catch (err) {
                    console.error(err)
                }
                break;
            case "WalletConnect":

                this.connector.on("connect", (error, payload) => {
                    if (error) {
                        throw error;
                    }
                    this.address = payload.params[0].accounts[0];
                }
                );

                this.connector.on("session_update", (error, payload) => {
                    alert(error + payload)
                    if (error) {
                        throw error;
                    }
                    // Get updated accounts 

                });

                if (!this.connector.connected) {
                    await this.connector.createSession().then(data => { console.log(data) })
                }
                else {
                    this.address = this.connector.accounts[0];
                }
                break;
            case "AlgoSigner":
                if (typeof AlgoSigner !== 'undefined') {
                    await AlgoSigner.connect()
                    let data = await AlgoSigner.accounts({ ledger: (this.main === true) ? 'MainNet' : 'TestNet' })
                    let SignerAdd = data[0].address
                    this.address = SignerAdd;
                    return SignerAdd

                } else {
                    alert('AlgoSigner is NOT installed.');
                };
                break;
            default:
                break;
        }

        function waitForAddress() {
            return new Promise(resolve => {
                var start_time = Date.now();
                function checkFlag() {
                    if (Pipeline.address !== "") {
                        resolve(Pipeline.address);
                    } else if (Date.now() > start_time + 60000) {
                        resolve("error occurred");
                    } else {
                        window.setTimeout(checkFlag, 200);
                    }
                }
                checkFlag();
            });
        }

        const address = await waitForAddress();
        return address;
    }

    static async sign(mytxnb, group = false) {

        console.log(mytxnb)
        let signedTxn = ""

        if (this.pipeConnector === "myAlgoWallet") {
            if (!group) {
                signedTxn = await this.wallet.signTransaction(mytxnb.toByte())
                signedTxn = signedTxn.blob;
                return signedTxn

            }
            else {
                mytxnb = mytxnb.map(txn => txn.toByte())
                signedTxn = await this.wallet.signTransaction(mytxnb).then(data => {
                    txns[0] = data[0].blob;
                    txns[1] = data[1].blob
                })
                return signedTxn
            }
        }
        else {

            let txns = []
            if (!group) {
                txns[0] = mytxnb
            }
            else {
                txns[0] = mytxnb[0]
                txns[1] = mytxnb[1]
            }

            console.log("Unencoded txns:")
            console.log(txns)

            /*
                    let prototxn = {
                        "amt": mytxnb.amount,
                        "fee": 1000,
                        "fv": mytxnb.lastRound - 1000,
                        "gen": mytxnb.genesisID,
                        "gh": new Uint8Array(Buffer.from(mytxnb.genesisHash, 'base64')),
                        "lv": mytxnb.lastRound,
                        "note": mytxnb.note,
                        "rcv": new Uint8Array(base32.decode.asBytes(mytxnb.to).slice(0, 32)),
                        "snd": new Uint8Array(base32.decode.asBytes(this.address).slice(0, 32)),
                        "type": "pay"
                    }
            
                    let prototxnASA = {};
                    let prototxnb = encode(prototxn);
                    let txns = [];
                    txns[0] = prototxnb;
            
                    if (this.index !== 0) {
                        prototxnASA = {
                            "aamt": mytxnb.amount,
                            "arcv": new Uint8Array(base32.decode.asBytes(mytxnb.to).slice(0, 32)),
                            "fee": 1000,
                            "fv": mytxnb.lastRound - 1000,
                            "gen": mytxnb.genesisID,
                            "gh": new Uint8Array(Buffer.from(mytxnb.genesisHash, 'base64')),
                            "lv": mytxnb.lastRound,
                            "note": mytxnb.note,
                            "snd": new Uint8Array(base32.decode.asBytes(this.address).slice(0, 32)),
                            "type": "axfer",
                            "xaid": parseInt(mytxnb.assetIndex)
                        }
                        prototxnb = encode(prototxnASA);
                        txns[0] = prototxnb;
                    }
                    
                            console.log(prototxnb)
                            console.log(new TextDecoder().decode(prototxnb))
                            console.log(JSON.stringify(decode(prototxnb)))
                    */
            // Sign transaction
            
            let txnsToSign = txns.map(txnb => {
                
                let packed = algosdk.encodeUnsignedTransaction(txnb)
                let encodedTxn = Buffer.from(packed).toString("base64")

                if (this.pipeConnector === "WalletConnect") {
                    return {
                        txn: encodedTxn,
                        message: "",
                        // Note: if the transaction does not need to be signed (because it's part of an atomic group
                        // that will be signed by another party), specify an empty singers array like so:
                        // signers: [],
                        authAddr: this.address
                    };
                }
                else {
                    return {txn:encodedTxn}
                }
            });

            let requestParams = !group?[txnsToSign]:txnsToSign
            console.log("TXNs to Sign:")
            console.log(requestParams)

            if (this.pipeConnector === "WalletConnect") {

                var request = formatJsonRpcRequest("algo_signTxn", requestParams);
    
                request.id = this.connector._handshakeId;
    
                console.log(request);
    
                try {
                    let result = await this.connector.sendCustomRequest(request);
                    let signedPartialTxn = result[0]
                    let rawSignedTxn = Buffer.from(signedPartialTxn, "base64");
                    return new Uint8Array(rawSignedTxn);
                }
                catch (error) { console.log(error) }
            }
            else {
                try {
                    let result = await AlgoSigner.signTxn(requestParams)
                    let signedPartialTxn = result[0].blob
                    let rawSignedTxn = Buffer.from(signedPartialTxn, "base64");
                    return new Uint8Array(rawSignedTxn);
                }
                catch (error) { console.log(error) }
            }
        }
    }

    static makeAppCall(appId, appArgs, params) {
        let id = parseInt(appId)
        let converted = []
        appArgs.forEach(arg => {
            converted.push(
                typeof arg === "number" ? algosdk.encodeUint64(arg) : u8array(arg)
            )
        })
        appArgs = converted

        let txn = algosdk.makeApplicationNoOpTxn(this.address, params, id, appArgs)

        return txn

    }

    static makeTransfer(address, amt, myNote, index = 0, params = {}) {
        var buf = new Array(myNote.length)
        var encodedNote = new Uint8Array(buf)
        for (var i = 0, strLen = myNote.length; i < strLen; i++) {
            encodedNote[i] = myNote.charCodeAt(i)
        }

        console.log('My encoded note: ' + encodedNote)

        let txn = {
            from: this.address,
            to: address,
            amount: parseInt(amt),
            note: encodedNote,
            genesisId: params.genesisID,
            genesisHash: params.genesisHash,
            type: 'pay',
            flatFee: true,
            fee: 1000,
            firstRound: parseInt(params['last-round']),
            lastRound: parseInt(params['last-round'] + 1000),
        }

        if (index !== 0) {
            this.index = index;
            txn.type = 'axfer'
            txn.assetIndex = parseInt(index)
            txn = algosdk.makeAssetTransferTxn(txn.from, txn.to, txn.fee, txn.amount, undefined, txn.firstRound, txn.lastRound, txn.note, txn.genesisHash, txn.genesisId, txn.assetIndex, undefined)
        }
        else {
            txn = algosdk.makePaymentTxn(txn.from, txn.to, txn.fee, txn.amount, undefined, txn.firstRound, txn.lastRound, txn.note, txn.genesisHash, txn.genesisId, undefined)
        }

        txn.fee = 1000

        console.log(txn);
        return txn
    }

    static async send(address, amt, myNote, _sendingAddress, _wallet, index = 0) {

        let client = await configClient(this.main, this.EnableDeveloperAPI)
        let transServer = client.tranServer
        let params = client.params

        try {
            let txn = this.makeTransfer(address, amt, myNote, index, params)

            let signedTxn = {};

            signedTxn = await this.sign(txn)

            console.log(signedTxn)

            let transactionID = await sendTxns(signedTxn, transServer, this.EnableDeveloperAPI)

            this.txID = transactionID
            if (transactionID === undefined) { transactionID = "Transaction failed" }
            return transactionID
        } catch (err) {
            console.error(err)
        }
    }

    static async createAsa(asaObject = {}) {

        let txn = {}

        let client = await configClient(this.main, this.EnableDeveloperAPI)
        let transServer = client.tranServer
        let params = client.params

        let myNote = asaObject.note || "New Asa"

        let buf = new Array(myNote.length)
        let encodedNote = new Uint8Array(buf)
        for (let i = 0, strLen = myNote.length; i < strLen; i++) {
            encodedNote[i] = myNote.charCodeAt(i)
        }

        asaObject.note = encodedNote

        console.log('My encoded note: ' + encodedNote)

        txn = createAsaTxn(params, asaObject)

        txn.fee = 1000

        console.log(txn);

        let signedTxn = {};

        signedTxn = await this.sign(txn,false)

        console.log(signedTxn)

        try {

            let transactionID = await sendTxns(signedTxn, transServer, this.EnableDeveloperAPI)

            this.txID = transactionID
            if (transactionID === undefined) { transactionID = "Transaction failed" }
            return transactionID
        } catch (err) {
            console.error(err)
        }
    }

    static async compileProgram(client, teal) {
        let encoder = new TextEncoder();
        let programBytes = encoder.encode(teal);
        try {
            let compileResponse = await client.compile(programBytes).do();
            return compileResponse;
        }
        catch (error) { console.log(error) }
    }

    static async deployTeal(teal = "", teal2 = "", bytesInts = [], appArgs = [], onComplete = 0) {
        if (teal !== "") {

            let algodClient = ""

            if (!this.main) {
                algodClient = new algosdk.Algodv2("", 'https://api.testnet.algoexplorer.io', '');
            }
            else {
                algodClient = new algosdk.Algodv2("", 'https://algoexplorerapi.io', '');
            }

            let clientb = await configClient(this.main, this.EnableDeveloperAPI)
            let transServer = clientb.tranServer

            let compiled = ""

            compiled = await this.compileProgram(algodClient, teal)
            let compiledClear = await this.compileProgram(algodClient, teal2)

            let params = await algodClient.getTransactionParams().do();

            let converted = []
            appArgs.forEach(arg => {
                converted.push(
                    typeof arg === "number" ? algosdk.encodeUint64(arg) : u8array(arg)
                )
            })
            appArgs = converted

            console.log(appArgs)

            let lbytes = bytesInts[0]
            let gbytes = bytesInts[1]
            let lints = bytesInts[2]
            let gints = bytesInts[3]

            let txn = algosdk.makeApplicationCreateTxnFromObject({
                suggestedParams: {
                    ...params,
                },
                from: this.address,
                numLocalByteSlices: lbytes,
                numGlobalByteSlices: gbytes,
                numLocalInts: lints,
                numGlobalInts: gints,
                appArgs: appArgs,
                approvalProgram: new Uint8Array(Buffer.from(compiled.result, "base64")),
                clearProgram: new Uint8Array(Buffer.from(compiledClear.result, "base64")),
                onComplete: onComplete,
            });

            let signedTxn = await this.sign(txn)
            console.log(signedTxn)
            let response = await sendTxns(signedTxn, transServer, this.EnableDeveloperAPI);
            console.log(response)
            let appId = await getAppIndex(response, this.main)
            console.log(appId)
            return appId
        }
        else {
            console.log("Teal program or clear program empty")
        }
    }

    static async optIn(appId = 0, appArgs = []) {
        let algodClient = ""

        if (!this.main) {
            algodClient = new algosdk.Algodv2("", 'https://api.testnet.algoexplorer.io', '');
        }
        else {
            algodClient = new algosdk.Algodv2("", 'https://algoexplorerapi.io', '');
        }

        let clientb = await configClient(this.main, this.EnableDeveloperAPI)
        let transServer = clientb.tranServer

        let params = await algodClient.getTransactionParams().do();

        let converted = []
        appArgs.forEach(arg => {
            converted.push(
                typeof arg === "number" ? algosdk.encodeUint64(arg) : u8array(arg)
            )
        })
        appArgs = converted

        let txn = ""

        txn = algosdk.makeApplicationOptInTxnFromObject({
            suggestedParams: {
                ...params,
            },
            from: this.address,
            appIndex: parseInt(appId),
            appArgs: appArgs
        });

        let signedTxn = await this.sign(txn);
        console.log(signedTxn)
        let response = await sendTxns(signedTxn, transServer, this.EnableDeveloperAPI)
        console.log(response)
        return response
    }

    static async appCall(appId, appArgs) {

        let clientb = await configClient(this.main, this.EnableDeveloperAPI)
        let transServer = clientb.tranServer
        let params = clientb.params

        let txn = this.makeAppCall(appId, appArgs, params)

        let signedTxn = await this.sign(txn);
        console.log(signedTxn)
        let response = await sendTxns(signedTxn, transServer, this.EnableDeveloperAPI)
        console.log(response)

        return response

    }

    static async getParams() {
        let client = await configClient(this.main, this.EnableDeveloperAPI)
        return client.params
    }

    static async deleteApp(appId = 0) {
        let algodClient = ""

        if (!this.main) {
            algodClient = new algosdk.Algodv2("", 'https://api.testnet.algoexplorer.io', '');
        }
        else {
            algodClient = new algosdk.Algodv2("", 'https://algoexplorerapi.io', '');
        }
        let params = await algodClient.getTransactionParams().do();

        let txn = algosdk.makeApplicationDeleteTxnFromObject({
            suggestedParams: {
                ...params,
            },
            from: this.address,
            appIndex: parseInt(appId),
        });

        let signedTxn = await this.sign(txn);

        let clientb = await configClient(this.main, this.EnableDeveloperAPI)
        let transServer = clientb.tranServer

        try {
            let response = await sendTxns(signedTxn, transServer, this.EnableDeveloperAPI)
            console.log(response)
            return response
        }
        catch (error) { console.log(error) }
    }

    static async appCallWithTxn(appId = 0, appArgs = [], reciever = "", amount = 0, note = "", index = 0) {
        let id = parseInt(appId)

        let clientb = await configClient(this.main, this.EnableDeveloperAPI)
        let transServer = clientb.tranServer
        let params = clientb.params

        let txns = [
            this.makeAppCall(id, appArgs, params),
            this.makeTransfer(reciever, amount, note, index, params)
        ]

        txns = algosdk.assignGroupID(txns)

        console.log(txns)

        let signedTxn = await this.sign(txns, true)

        console.log(signedTxn)
        let response = await sendTxns(signedTxn, transServer, this.EnableDeveloperAPI)
        console.log(response)

        return response

    }
}

/* usage

update balance at intervals:

componentDidMount() {
      this.interval = setInterval(() => this.setState({balance: Pipeline.myBalance}), 1000);
    }

var balance = 0;

Pipeline.balance(address).then(data => balance = data);

const myAlgoWallet = Pipeline.init();

//useTestNet

Pipeline.main = false;

Pipeline.connect(myAlgoWallet)
    .then(data => {
        console.log(data);
    });

Pipeline.send(address, amount, note, sendingAddress, myAlgowallet, index)
    .then(data => {
        console.log(data);
    });

    */
